# coding: utf-8

"""
    Zuora API Reference

    REST API reference for the Zuora Billing, Payments, and Central Platform! Check out the [REST API Overview](https://www.zuora.com/developer/api-references/api/overview/).

    The version of the OpenAPI document: 2024-05-20
    Contact: docs@zuora.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ExpandedProductRatePlan(BaseModel):
    """
    ExpandedProductRatePlan
    """ # noqa: E501
    # avoid validation
    def __init__(self, **kwargs):
        # Directly assign values without validation using `construct()`
        model = self.construct(**kwargs)
        self.__dict__.update(model.__dict__)

    def __setattr__(self, name, value):
        # Override setattr to bypass validation when setting attributes
        object.__setattr__(self, name, value)

    product_id: Optional[StrictStr] = Field(default=None, alias="productId")
    name: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    effective_start_date: Optional[date] = Field(default=None, alias="effectiveStartDate")
    effective_end_date: Optional[date] = Field(default=None, alias="effectiveEndDate")
    grade: Optional[StrictInt] = None
    product_rate_plan_number: Optional[StrictStr] = Field(default=None, alias="productRatePlanNumber")
    id: Optional[StrictStr] = None
    created_by_id: Optional[StrictStr] = Field(default=None, alias="createdById")
    created_date: Optional[StrictStr] = Field(default=None, alias="createdDate")
    updated_by_id: Optional[StrictStr] = Field(default=None, alias="updatedById")
    updated_date: Optional[StrictStr] = Field(default=None, alias="updatedDate")
    product: Optional[ExpandedProduct] = None
    product_rate_plan_charges: Optional[List[ExpandedProductRatePlanCharge]] = Field(default=None, alias="productRatePlanCharges")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["productId", "name", "description", "effectiveStartDate", "effectiveEndDate", "grade", "productRatePlanNumber", "id", "createdById", "createdDate", "updatedById", "updatedDate", "product", "productRatePlanCharges"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExpandedProductRatePlan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of product
        if self.product:
            _dict['product'] = self.product.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in product_rate_plan_charges (list)
        _items = []
        if self.product_rate_plan_charges:
            for _item_product_rate_plan_charges in self.product_rate_plan_charges:
                if _item_product_rate_plan_charges:
                    _items.append(_item_product_rate_plan_charges.to_dict())
            _dict['productRatePlanCharges'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExpandedProductRatePlan from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "productId": obj.get("productId"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "effectiveStartDate": obj.get("effectiveStartDate"),
            "effectiveEndDate": obj.get("effectiveEndDate"),
            "grade": obj.get("grade"),
            "productRatePlanNumber": obj.get("productRatePlanNumber"),
            "id": obj.get("id"),
            "createdById": obj.get("createdById"),
            "createdDate": obj.get("createdDate"),
            "updatedById": obj.get("updatedById"),
            "updatedDate": obj.get("updatedDate"),
            "product": ExpandedProduct.from_dict(obj["product"]) if obj.get("product") is not None else None,
            "productRatePlanCharges": [ExpandedProductRatePlanCharge.from_dict(_item) for _item in obj["productRatePlanCharges"]] if obj.get("productRatePlanCharges") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj

from zuora_sdk.models.expanded_product import ExpandedProduct
from zuora_sdk.models.expanded_product_rate_plan_charge import ExpandedProductRatePlanCharge
# TODO: Rewrite to not use raise_errors
ExpandedProductRatePlan.model_rebuild(raise_errors=False)

def convert_snake_dict_to_camel(_dict: dict, properties: list[str]):
    if not isinstance(_dict, dict):
        return _dict
    new_dict = {}
    for k, v in _dict.items():
        new_key = snake_to_camel(k)
        if properties is not None and isinstance(properties, list) and new_key in properties:
            new_dict[new_key] = v
        else:
            new_dict[k] = v
    return new_dict
    pass


def snake_to_camel(name):
    if name is None or '_' not in name:
        return name
    components = name.split('_')
    return components[0] + ''.join(x.title() for x in components[1:])
